include:
  - template: Jobs/Code-Quality.gitlab-ci.yml
  - template: Security/Container-Scanning.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - remote: 'https://gitlab.com/gitlab-org/frontend/untamper-my-lockfile/-/raw/main/.gitlab-ci-template.yml'
  - project: 'gitlab-org/quality/pipeline-common'
    file:
      - '/ci/danger-review.yml'

docs-lint:
  extends: .rules:docs-changes
  image: registry.gitlab.com/gitlab-org/gitlab-docs/lint-markdown:alpine-3.15-vale-2.15.0-markdownlint-0.31.0
  stage: test
  needs: []
  script:
    - make lint

rubocop:
  extends: .rules:code-changes
  image: ruby:2.7
  stage: test
  needs: []
  variables:
    BUNDLE_INSTALL_ARGS: "--path vendor/bundle"
  script:
    - make rubocop

rspec:
  extends: .rules:code-changes
  image: ruby:2.7
  stage: test
  needs: []
  variables:
    RSPEC_ARGS: "--format doc --format RspecJunitFormatter --out rspec.xml"
    BUNDLE_INSTALL_ARGS: "--path vendor/bundle"
  script:
    - pwd > .gdk-install-root
    - make rspec
  cache:
    key: "ruby-2.7-bundle"
    paths:
      - ./vendor/bundle
  artifacts:
    paths:
      - rspec.xml
    reports:
      junit: rspec.xml
      cobertura: coverage/coverage.xml

code_quality:
  extends:
    - .docker:use-docker-in-docker
  rules: !reference ['.rules:code-changes', rules]

container_scanning:
  before_script:
    - export DOCKER_IMAGE=${DEFAULT_IMAGE}
  needs:
    - release-image
  rules: !reference ['.rules:code-changes', rules]

gemnasium-dependency_scanning:
  rules: !reference ['.rules:code-changes', rules]

shellcheck:
  extends: .rules:code-changes
  stage: test
  needs: []
  image: ruby:2.7
  script:
    - apt-get update
    - make shellcheck

checkmake:
  stage: test
  needs: []
  extends: .rules:code-changes
  image: registry.gitlab.com/gitlab-org/gitlab-development-kit/asdf-bootstrapped-verify:main
  script:
    - make checkmake

yard:
  stage: test
  needs: []
  image: ruby:2.7
  script:
    - bundle install --jobs 4 --path vendor/bundle
    - bundle exec yardoc
  cache:
    key: "ruby-2.7-bundle"
    paths:
      - ./vendor/bundle
  artifacts:
    expire_in: 1 week
    paths:
      - yard/*

verify-gdk-example-yml:
  extends: .rules:code-changes
  image: ruby:2.7
  stage: test
  needs: []
  script:
    - make verify-gdk-example-yml

verify-asdf-combine:
  extends: .rules:code-changes
  image: ruby:2.7
  stage: test
  needs: []
  artifacts:
    when: on_failure
    paths:
      - .tool-versions
  script:
    - make verify-asdf-combine
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
    - if: '$CI_MERGE_REQUEST_IID'
      changes:
        - ".tool-versions*"
        - "support/asdf-combine"
        - "support/ci/verify-asdf-combine"

verify-makefile-config:
  extends: .rules:code-changes
  image: ruby:2.7
  stage: test
  needs: []
  script:
    - support/ci/verify-makefile-config
